﻿using System.ComponentModel;

using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Popup;

namespace TestProject
{
    /// <summary>
    /// 커스텀 토큰 에디터
    /// </summary>
    [ToolboxItem(true)]
    public class CustomTokenEdit : TokenEdit
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 속성 - Properties

        /// <summary>
        /// 속성
        /// </summary>
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public new RepositoryItemCustomTokenEdit Properties
        {
            get
            {
                return base.Properties as RepositoryItemCustomTokenEdit;
            }
        }

        #endregion
        #region 에디터 타입명 - EditorTypeName

        /// <summary>
        /// 에디터 타입명
        /// </summary>
        public override string EditorTypeName
        {
            get
            {
                return RepositoryItemCustomTokenEdit.CustomEditName;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - CustomTokenEdit()

        /// <summary>
        /// 생성자
        /// </summary>
        static CustomTokenEdit()
        {
            RepositoryItemCustomTokenEdit.RegisterCustomTokenEdit();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 팝업 폼 생성하기 - CreatePopupForm()

        /// <summary>
        /// 팝업 폼 생성하기
        /// </summary>
        /// <returns>토큰 에디터 팝업 폼</returns>
        protected override TokenEditPopupForm CreatePopupForm()
        {
            return new CustomTokenEditPopupForm(this);
        }

        #endregion
    }
}