﻿using System;

namespace TestProject
{
    /// <summary>
    /// 오브젝트 래퍼
    /// </summary>
    public class ObjectWrapper : ICloneable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 소스
        /// </summary>
        private int source;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 소스 - Source

        /// <summary>
        /// 소스
        /// </summary>
        public int Source
        {
            get
            {
                return this.source;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ObjectWrapper(source)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="source">소스</param>
        public ObjectWrapper(int source)
        {
            this.source = source;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return Source.ToString();
        }

        #endregion
        #region 복제하기 - Clone()

        /// <summary>
        /// 복제하기
        /// </summary>
        /// <returns>복제 객체</returns>
        public ObjectWrapper Clone()
        {
            return new ObjectWrapper(Source);
        }

        #endregion
        #region 복제하기 - ICloneable.Clone()

        /// <summary>
        /// 복제하기
        /// </summary>
        /// <returns>복제 객체</returns>
        object ICloneable.Clone()
        {
            return Clone();
        }

        #endregion
    }
}