﻿using DevExpress.XtraEditors.Drawing;
using DevExpress.XtraEditors.Registrator;
using DevExpress.XtraEditors.Repository;
using DevExpress.XtraEditors.ViewInfo;

namespace TestProject
{
    /// <summary>
    /// 저장소 항목 커스텀 토큰 에디터
    /// </summary>
    [UserRepositoryItem("RegisterCustomTokenEdit")]
    public class RepositoryItemCustomTokenEdit : RepositoryItemTokenEdit
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 커스텀 에디터명
        /// </summary>
        public const string CustomEditName = "CustomTokenEdit";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 에디터 타입명 - EditorTypeName

        /// <summary>
        /// 에디터 타입명
        /// </summary>
        public override string EditorTypeName
        {
            get
            {
                return CustomEditName;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - RepositoryItemCustomTokenEdit()

        /// <summary>
        /// 생성자
        /// </summary>
        static RepositoryItemCustomTokenEdit()
        {
            RegisterCustomTokenEdit();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - RepositoryItemCustomTokenEdit()

        /// <summary>
        /// 생성자
        /// </summary>
        public RepositoryItemCustomTokenEdit()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 커스텀 토큰 에디터 등록하기 - RegisterCustomTokenEdit()

        /// <summary>
        /// 커스텀 토큰 에디터 등록하기
        /// </summary>
        public static void RegisterCustomTokenEdit()
        {
            EditorRegistrationInfo.Default.Editors.Add
            (
                new EditorClassInfo
                (
                    CustomEditName,
                    typeof(CustomTokenEdit),
                    typeof(RepositoryItemCustomTokenEdit),
                    typeof(TokenEditViewInfo),
                    new TokenEditPainter(),
                    true,
                    null
                )
            );
        }

        #endregion
    }
}