﻿using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 토큰 레지스트리
    /// </summary>
    public class TokenRegistry
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 인스턴스
        /// </summary>
        private static TokenRegistry _instance = new TokenRegistry();

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 태스크 딕셔너리
        /// </summary>
        private Dictionary<int, string> taskDictionary;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TokenRegistry()

        /// <summary>
        /// 생성자
        /// </summary>
        protected TokenRegistry()
        {
            this.taskDictionary = LoadTokenDictionary();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 토큰 딕셔너리 구하기 - GetTokenDictionary()

        /// <summary>
        /// 토큰 딕셔너리 구하기
        /// </summary>
        /// <returns>토큰 딕셔너리</returns>
        public static Dictionary<int, string> GetTokenDictionary()
        {
            return _instance.taskDictionary;
        }

        #endregion
        #region ID 구하기 - GetID(token)

        /// <summary>
        /// ID 구하기
        /// </summary>
        /// <param name="token">토큰</param>
        /// <returns>ID</returns>
        public static int GetID(string token)
        {
            foreach(KeyValuePair<int, string> keyValuePair in _instance.taskDictionary)
            {
                if(keyValuePair.Value == token)
                {
                    return keyValuePair.Key;
                }
            }

            return -1;
        }

        #endregion
        #region 토큰 구하기 - GetToken(id)

        /// <summary>
        /// 토큰 구하기
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>토큰</returns>
        public static string GetToken(int id)
        {
            return _instance.taskDictionary[id];
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 토큰 딕셔너리 로드하기 - LoadTokenDictionary()

        /// <summary>
        /// 토큰 딕셔너리 로드하기
        /// </summary>
        /// <returns>토큰 딕셔너리</returns>
        protected Dictionary<int, string> LoadTokenDictionary()
        {
            Dictionary<int, string> dictionary = new Dictionary<int, string>();

            dictionary.Add(0, "One"  );
            dictionary.Add(1, "Two"  );
            dictionary.Add(2, "Three");
            dictionary.Add(3, "Four" );

            return dictionary;
        }

        #endregion
    }
}